# **********************************************************************
#
# Copyright (c) 2003-2008 ZeroC, Inc. All rights reserved.
#
# This copy of Ice is licensed to you under the terms described in the
# ICE_LICENSE file included in this distribution.
#
# **********************************************************************

# Ice version 3.3.0
# Generated from file `Properties.ice'

require 'Ice'
require 'Ice/BuiltinSequences.rb'

module Ice

    if not defined?(::Ice::T_PropertyDict)
        T_PropertyDict = ::Ice::__defineDictionary('::Ice::PropertyDict', ::Ice::T_string, ::Ice::T_string)
    end

    if not defined?(::Ice::Properties_mixin)
        module Properties_mixin

            #
            # Operation signatures.
            #
            # def getProperty(key)
            # def getPropertyWithDefault(key, value)
            # def getPropertyAsInt(key)
            # def getPropertyAsIntWithDefault(key, value)
            # def getPropertyAsList(key)
            # def getPropertyAsListWithDefault(key, value)
            # def getPropertiesForPrefix(prefix)
            # def setProperty(key, value)
            # def getCommandLineOptions()
            # def parseCommandLineOptions(prefix, options)
            # def parseIceCommandLineOptions(options)
            # def load(file)
            # def _clone()

            def inspect
                ::Ice::__stringify(self, T_Properties)
            end
        end
        class Properties
            include Properties_mixin
            
            def Properties.ice_staticId()
                '::Ice::Properties'
            end
        end

        if not defined?(::Ice::T_Properties)
            T_Properties = ::Ice::__declareLocalClass('::Ice::Properties')
        end

        T_Properties.defineClass(Properties, true, nil, [], [])
        Properties_mixin::ICE_TYPE = T_Properties
    end

    if not defined?(::Ice::PropertiesAdmin_mixin)
        module PropertiesAdmin_mixin
            include ::Ice::Object_mixin

            def ice_ids(current=nil)
                ['::Ice::Object', '::Ice::PropertiesAdmin']
            end

            def ice_id(current=nil)
                '::Ice::PropertiesAdmin'
            end

            #
            # Operation signatures.
            #
            # def getProperty(key, current=nil)
            # def getPropertiesForPrefix(prefix, current=nil)

            def inspect
                ::Ice::__stringify(self, T_PropertiesAdmin)
            end
        end
        class PropertiesAdmin
            include PropertiesAdmin_mixin
            
            def PropertiesAdmin.ice_staticId()
                '::Ice::PropertiesAdmin'
            end
        end
        module PropertiesAdminPrx_mixin

            def getProperty(key, _ctx=nil)
                PropertiesAdmin_mixin::OP_getProperty.invoke(self, [key], _ctx)
            end

            def getPropertiesForPrefix(prefix, _ctx=nil)
                PropertiesAdmin_mixin::OP_getPropertiesForPrefix.invoke(self, [prefix], _ctx)
            end
        end
        class PropertiesAdminPrx < ::Ice::ObjectPrx
            include PropertiesAdminPrx_mixin

            def PropertiesAdminPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
                ice_checkedCast(proxy, '::Ice::PropertiesAdmin', facetOrCtx, _ctx)
            end

            def PropertiesAdminPrx.uncheckedCast(proxy, facet=nil)
                ice_uncheckedCast(proxy, facet)
            end
        end

        if not defined?(::Ice::T_PropertiesAdmin)
            T_PropertiesAdmin = ::Ice::__declareClass('::Ice::PropertiesAdmin')
            T_PropertiesAdminPrx = ::Ice::__declareProxy('::Ice::PropertiesAdmin')
        end

        T_PropertiesAdmin.defineClass(PropertiesAdmin, true, nil, [], [])
        PropertiesAdmin_mixin::ICE_TYPE = T_PropertiesAdmin

        T_PropertiesAdminPrx.defineProxy(PropertiesAdminPrx, T_PropertiesAdmin)
        PropertiesAdminPrx::ICE_TYPE = T_PropertiesAdminPrx

        PropertiesAdmin_mixin::OP_getProperty = ::Ice::__defineOperation('getProperty', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, [::Ice::T_string], [], ::Ice::T_string, [])
        PropertiesAdmin_mixin::OP_getPropertiesForPrefix = ::Ice::__defineOperation('getPropertiesForPrefix', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, [::Ice::T_string], [], ::Ice::T_PropertyDict, [])
    end
end
